/*

   SgInterface.cpp - interface class

   Written by Zero (xmaste00).


   THIS SOFTWARE IS NOT COPYRIGHTED

   This source code is offered for use in the public domain.
   You may use, modify or distribute it freely.

   This source code is distributed in the hope that it will be useful but
   WITHOUT ANY WARRANTY.  ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
   DISCLAIMED.  This includes but is not limited to warranties of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

   If you find the source code useful, authors will kindly welcome
   if you give them credit and keep their names with their source code,
   but you are not forced to do so.

*/

#include "SgInterface.h"

SgMouse::SgMouse() {
	//tlacitko.resize(sizeof(SoMouseButtonEvent::Button));
	tlacitko.insert(make_pair(Mouse1,SoMouseButtonEvent::BUTTON1));
	stisknuto.insert(make_pair(Mouse1,false));
	tlacitko.insert(make_pair(Mouse2,SoMouseButtonEvent::BUTTON2));
	stisknuto.insert(make_pair(Mouse2,false));
	tlacitko.insert(make_pair(Mouse3,SoMouseButtonEvent::BUTTON3));
	stisknuto.insert(make_pair(Mouse3,false));
};

void SgMouse::setButton(const SoEvent * event){
	for(Tl=tlacitko.begin();Tl!=tlacitko.end();Tl++){
		if(SoMouseButtonEvent::isButtonPressEvent(event, Tl->second)) stisknuto[Tl->first]=true;
		if(SoMouseButtonEvent::isButtonReleaseEvent(event, Tl->second)) stisknuto[Tl->first]=false;
		cout << Tl->second << " " << Tl->first << " " << stisknuto[Tl->first]<<endl;
	};
};

bool SgMouse::getButton(t_tlacitko tl){
	return stisknuto[tl];
};

SgKeyboard::SgKeyboard() {
	klavesa.insert(make_pair(Vpred,SoKeyboardEvent::W));
	stisknuta.insert(make_pair(Vpred,false));
	klavesa.insert(make_pair(Vzad,SoKeyboardEvent::S));
	stisknuta.insert(make_pair(Vzad,false));
	klavesa.insert(make_pair(RotL,SoKeyboardEvent::Q));
	stisknuta.insert(make_pair(RotL,false));
	klavesa.insert(make_pair(RotR,SoKeyboardEvent::E));
	stisknuta.insert(make_pair(RotR,false));
	klavesa.insert(make_pair(TurnL,SoKeyboardEvent::LEFT_ARROW));
	stisknuta.insert(make_pair(TurnL,false));
	klavesa.insert(make_pair(TurnR,SoKeyboardEvent::RIGHT_ARROW));
	stisknuta.insert(make_pair(TurnR,false));
	klavesa.insert(make_pair(TurnUp,SoKeyboardEvent::UP_ARROW));
	stisknuta.insert(make_pair(TurnUp,false));
	klavesa.insert(make_pair(TurnDown,SoKeyboardEvent::DOWN_ARROW));
	stisknuta.insert(make_pair(TurnDown,false));
	klavesa.insert(make_pair(Stop,SoKeyboardEvent::SPACE));
	stisknuta.insert(make_pair(Stop,false));
	klavesa.insert(make_pair(Cfree,SoKeyboardEvent::F));
	stisknuta.insert(make_pair(Cfree,false));
	klavesa.insert(make_pair(Cfighter,SoKeyboardEvent::V));
	stisknuta.insert(make_pair(Cfighter,false));
	klavesa.insert(make_pair(Crestart,SoKeyboardEvent::R));
	stisknuta.insert(make_pair(Crestart,false));
/*	klavesa.insert(make_pair(Up,SoKeyboardEvent::LEFT_ARROW));
	stisknuta.insert(make_pair(Up,false));
	klavesa.insert(make_pair(Down,SoKeyboardEvent::RIGHT_ARROW));
	stisknuta.insert(make_pair(Down,false));*/
	klavesa.insert(make_pair(Left,SoKeyboardEvent::A));
	stisknuta.insert(make_pair(Left,false));
	klavesa.insert(make_pair(Right,SoKeyboardEvent::D));
	stisknuta.insert(make_pair(Right,false));
};

void SgKeyboard::setKey(const SoEvent * event){
	for(Kl=klavesa.begin();Kl!=klavesa.end();Kl++){
		if(SoKeyboardEvent::isKeyPressEvent(event, Kl->second)) stisknuta[Kl->first]=true;
		if(SoKeyboardEvent::isKeyReleaseEvent(event, Kl->second)) stisknuta[Kl->first]=false;
	};
};

bool SgKeyboard::getKey(t_klavesa key){
	return stisknuta[key];
};

SgCamera::SgCamera(){
	Camera = new SoPerspectiveCamera;
	Camera->ref();
    Camera->nearDistance = 0.1f;//4;
    Camera->farDistance = 4096;
	this->distance=4;
	this->height=1;
};
SgCamera::~SgCamera(){
	Camera->unref();
};


void SgCamera::setRot(SbRotation rot){
	SbVec3f upvec(0,1,0);
	rot.multVec(upvec,upvec);
	this->Camera->orientation.setValue(rot*SbRotation(upvec,M_PI));
}

void SgCamera::setPos(SbVec3f pos){
	SbVec3f lookat(0,this->height,this->distance);
	SbRotation rot = this->Camera->orientation.getValue();
	rot.multVec(lookat,lookat);
	this->Camera->position.setValue(pos+lookat);
}